package com.example.akka.test.actors;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.nio.channels.Channels;
import java.nio.channels.FileChannel;
import java.nio.channels.ReadableByteChannel;
import java.util.ArrayList;

import com.example.akka.test.msg.IdsRequired;

import akka.actor.Props;
import akka.actor.UntypedActor;
import akka.japi.Creator;

public class Output extends UntypedActor {

	public Output() {
	}

	public static Props props() {
		return Props.create(new Creator<Output>() {
			private static final long serialVersionUID = 1L;

			public Output create() throws Exception {
				return new Output();
			}
		});
	}

	private void outputToFile(ArrayList<String> allIdsForThisSlot,
			int currentTimeSlot) {

		// Output to file
		String outputFile = "./Slot_" + String.valueOf(currentTimeSlot)
				+ ".txt";
		try (RandomAccessFile randomAccessFile = new RandomAccessFile(new File(
				outputFile), "rw")) {
			// For each String output as a InputStream

			long numBytes = 0l;
			ByteArrayOutputStream baos = new ByteArrayOutputStream();

			for (int i = 0; i < allIdsForThisSlot.size(); i++) {
				baos.write(allIdsForThisSlot.get(i).getBytes());
				numBytes += allIdsForThisSlot.get(i).getBytes().length;
			}
			InputStream inputStream = new ByteArrayInputStream(
					baos.toByteArray());
			// Move the cursor to the end of the file
			randomAccessFile.seek(randomAccessFile.length());
			// Obtain the a file channel from the RandomAccessFile
			try (FileChannel fileChannel = randomAccessFile.getChannel();
					ReadableByteChannel inputChannel = Channels
							.newChannel(inputStream);) {
				fileChannel.transferFrom(inputChannel, 0, numBytes);
				fileChannel.truncate(numBytes);
			} catch (IOException e) {
				e.printStackTrace();
			}

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void onReceive(Object msg) throws Exception {
		if (msg instanceof IdsRequired) {
			outputToFile(((IdsRequired) msg).getIds(),
					((IdsRequired) msg).getSlot());
		}
	}

}
