package com.example.akka.test.actors;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import akka.actor.Props;
import akka.actor.UntypedActor;
import akka.japi.Creator;

public class UnusedIds extends UntypedActor {

	private ArrayList<String> unusedIds = new ArrayList<String>(1000000);
	private BigDecimal lastIdGenerated;

	public UnusedIds() {
		
	}

	public static Props props() {
		return Props.create(new Creator<UnusedIds>() {
			private static final long serialVersionUID = 1L;

			public UnusedIds create() throws Exception {
				return new UnusedIds();
			}
		});
	}

	private void generateIds(Long msg) {
		for (long i = 0; i < msg.longValue(); i++) {
			unusedIds.add(String.valueOf(i));
		}
		lastIdGenerated = new BigDecimal(unusedIds.get(unusedIds.size()-1));
		getSender().tell(new String("UIdsGenerated"), getSelf());
	}

	private void getIds(Integer count) {
		List<String> msg = null;
		if (unusedIds.size() > count) {
			msg = new ArrayList<String>(unusedIds.subList(0, count));
			unusedIds.subList(0, count).clear();
		} else {
			int startnum = lastIdGenerated.intValue();
			int limit = 10000;
			if(count > 10000)
				limit = count*5;
			for (int i = startnum+1; i < (limit+startnum); i++) {
				unusedIds.add(String.valueOf(i));
			}
			msg = new ArrayList<String>(unusedIds.subList(0, count));
			unusedIds.subList(0, count).clear();
		}
		getSender().tell(msg, getSelf());
	}

	@Override
	public void onReceive(Object msg) throws Exception {
		if( msg instanceof Integer) {
			// Request for unused Ids
			getIds((Integer) msg);
		} else if(msg instanceof Long) {
			// Build an initial pool of Ids to use
			generateIds((Long) msg);
		}
	}
}
